#include <iostream.h>
#include "ggen.h"

class g_dump : public target_t {
    public:
	virtual void emit(const design *d);
	virtual void emit(const ellipse_seg *e);
	virtual void emit(const circle_seg *c);
	virtual void emit(const line_seg *l);
	void emit(const segment *s);
};


void g_dump::emit(const design *d)
{
	cout << "g_dump design emission" << endl;
	segment *s=d->begin;
	if (!s) {
		cout << "what?  Null design?" << endl;
		return;
	}
	cout << "x range [ " << d->xmin << " , " << d->xmax << " ]" << endl;
	cout << "y range [ " << d->ymin << " , " << d->ymax << " ]" << endl;
	for (; s; s=s->next) { s->emit(this); }
}

void g_dump::emit(const segment *s)
{
	cout << "Segment: " << s->start << " to " << s->end << endl;

}
void g_dump::emit(const line_seg *l)
{
	emit((segment *)l);
	cout << "  ordinary line" << endl;
}

void g_dump::emit(const circle_seg *c)
{
	emit((segment *)c);
	cout << "   circle  center " << c->center << " radius " << c->radius << endl;
	cout << "           angles " << c->t_start << " to " << c->t_end << endl;
	cout << "           direction " << c->dir << endl;
}

void g_dump::emit(const ellipse_seg *e)
{
	emit((segment *)e);
	cout << "   ellipse center " << e->center << " radii " << e->rx << ", " << e->ry << endl;
	cout << "           angles " << e->t_start << " to " << e->t_end << endl;
	cout << "           direction " << e->dir << endl;
	if (e->circles)
		for (segment *s=e->circles->begin; s; s=s->next) { s->emit(this); }
}

target_t* get_dump(void)
{
	return new g_dump();
}
