#include <iostream.h>
#include "ggen.h"

#define MAXS 50
class g_fish : public target_t {
    public:
	g_fish(ostream &_os) { os = &_os; }
	virtual void emit(const design *d);
	virtual void emit(const ellipse_seg *e);
	virtual void emit(const circle_seg *c);
	virtual void emit(const line_seg *l);
	void emit(const segment *s);
	ostream *os;
	double x[MAXS];
	double y[MAXS];
	double r[MAXS];
	int spos;
};


void g_fish::emit(const design *d)
{
	// cout << "g_fish design emission" << endl;
	segment *s=d->begin;
	if (!s) {
		cout << "what?  Null design?" << endl;
		return;
	}

	x[0] = s->start.x;
	y[0] = s->start.y;
	r[0] = 0.0;
	spos=1;

	for (; s; s=s->next) { s->emit(this); }

	int i;

	// we also know xmin and ymin, don't know if Superfish understands that
	*os << "xmax " << d->xmax << endl;
	*os << "ymax " << d->ymax << endl;

	*os << "nseg " << spos << endl << endl;
	// need to break line every 80 columns or so
	// maybe it would be better to skip front and go
	// directly to automesh.in
	*os << "zseg"; for (i=0;i<spos;i++) { *os << " " << x[i]; if (i%5==4) *os << endl << "  "; } *os << endl;
	*os << "rseg"; for (i=0;i<spos;i++) { *os << " " << y[i]; if (i%5==4) *os << endl << "  "; } *os << endl;
	*os << "cseg"; for (i=0;i<spos;i++) { *os << " " << r[i]; if (i%5==4) *os << endl << "  "; } *os << endl;
}

void g_fish::emit(const segment *s)
{
}

void g_fish::emit(const line_seg *l)
{
	x[spos] = l->end.x;
	y[spos] = l->end.y;
	r[spos] = 0.0;
	spos++;	
}

void g_fish::emit(const circle_seg *c)
{
	x[spos] = c->end.x;
	y[spos] = c->end.y;
	r[spos] = c->dir ? c->radius : -c->radius;
	spos++;	
}

void g_fish::emit(const ellipse_seg *e)
{
	if (e->circles)
		for (segment *s=e->circles->begin; s; s=s->next) { s->emit(this); }
	else {
		*os << "% unconverted ellipse not supported by Superfish driver" << endl;
		*os <<  e->end.x << " " << e->end.y << " lineto" << endl;
	}
}

target_t* get_fish(ostream &os)
{
	return new g_fish(os);
}
