#include <iostream.h>
#include "ggen.h"

class g_ps : public target_t {
    public:
	g_ps(ostream &_os) { os = &_os; }
	virtual void emit(const design *d);
	virtual void emit(const ellipse_seg *e);
	virtual void emit(const circle_seg *c);
	virtual void emit(const line_seg *l);
	void emit(const segment *s);
	ostream *os;
};


void g_ps::emit(const design *d)
{
	// cout << "g_ps design emission" << endl;
	segment *s=d->begin;
	if (!s) {
		cout << "what?  Null design?" << endl;
		return;
	}

	// Doesn't belong here, but helps debugging
	*os << endl;
	// *os << "%!PS-Adobe-3.0" << endl;
	// *os << "10 10 scale 0.1 setlinewidth" << endl;

	*os << "newpath" << endl;
	*os << s->start.x << " " << s->start.y << " moveto" << endl;
	for (; s; s=s->next) { s->emit(this); }
	*os << "stroke" << endl;
}

void g_ps::emit(const segment *s)
{
}

void g_ps::emit(const line_seg *l)
{
	*os << l->end.x << " " << l->end.y << " lineto" << endl;
}

void g_ps::emit(const circle_seg *c)
{
	double f = c->dir ? (180/pi) : (180/pi) ;
	*os << c->center.x << " " << c->center.y << " " << c->radius << " "
	     << c->t_start*f << " " << c->t_end*f;
	if (c->dir) *os << " arc"  << endl;
	       else *os << " arcn" << endl;
}

void g_ps::emit(const ellipse_seg *e)
{
	if (e->circles)
		for (segment *s=e->circles->begin; s; s=s->next) { s->emit(this); }
	else {
		*os << "% unconverted ellipse not supported by postscript driver" << endl;
		*os <<  e->end.x << " " << e->end.y << " lineto" << endl;
	}
}

target_t* get_ps(ostream &os)
{
	return new g_ps(os);
}
