#include "ggen.h"

void final(target_t *targ)
{
	// cout << "===real version" << endl;

	const double pi=3.1415926535;
	point orig( 0.0, 0.0);
	point iris(10.2, 5.5);   // average beta for first half-cell = 0.34
	point irix(38.1, 5.5);   // average beta for next full cell = 0.93
	point anod(50.0, 0.0);
	design *d = new design();
	d->debug=0;

	double slope1=10;   // degrees
	double slope2=18;   // degrees

	line_ray    r4(d,iris,0);
	line_ray    r5(d,anod,0.5*pi);
	join(d,r5,r4);

	ellipse_ray r2x(d,irix,3.0,6.0,pi,false);
	line_ray    r3x(d,r2x,(90+slope2)*pi/180.);

	design *dy = new design();
	ellipse_ray r2y(dy,iris,3.0,6.0,0,true);
	line_ray    r3y(dy,r2y,(90-slope2)*pi/180.);

	join(d,r3x,r3y,9.0);
	dy->reverse();
	d->add(dy);

	ellipse_ray r2(d,iris,3.0,6.0,pi,false);
	line_ray    r3(d,r2,(90+slope1)*pi/180.);

	line_ray    r1(d,orig,0.5*pi);
	join(d,r3,r1,2.5);

	// cout << "emitting" << endl;
	// d->emit(targ);
	d->reverse();

	// cout << "eliminating ellipses" << endl;
	d->eliminate_ellipses();

	// cout << "emitting" << endl;
	d->emit(targ);

	// cout << "reversing" << endl;
	// cout << "emitting" << endl;
	// d->emit(targ);
}

target_t* get_ps(ostream &os);
target_t* get_fish(ostream &os);
target_t* get_dump(void);
int main(int argc, char *argv[])
{
	target_t *targ;
	if (argc > 1 && strcmp(argv[1],"ps")==0 )
		targ = get_ps(cout);
	else if (argc > 1 && strcmp(argv[1],"fish")==0 )
		targ = get_fish(cout);
	else
		targ = get_dump();
	// stupid(targ);
	final(targ);
}
